package com.nec.websocket;
import java.io.IOException;
import java.util.LinkedList;

import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.ServerEndpoint;

@ServerEndpoint(value = "/chat")
public class Chat {

    private static final LinkedList<Session> clients = new LinkedList<Session>();

    @OnOpen
    public void connect (Session session) {
        clients.add(session);
        System.out.println("server open");
    }

    @OnMessage
    public void receiveMessage(String message, Session session) {
        for (Session client : clients) {
            try {
                client.getBasicRemote().sendText(message);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @OnClose
    public void close (Session session) {
        clients.remove(session);
        System.out.println("server close");
    }

    @OnError
    public void error (Throwable e) {
        e.printStackTrace();
    }
}
